#include <iostream>

using namespace std;

pair<long long, long long> find_persistance(long long n, long long c) {
    if(n < 10)
        return make_pair(0, n);
    long long r = 1;
    while(n > 0) {
        long long i = n % 10;
        n /= 10;
        r *= i;
    }
    if(r < 10)
        return make_pair(c, r);
    else
        return find_persistance(r, c + 1);
}

int main() {
    long long n;
    cin>>n;
    for(long long i = 0; true; i++) {
        //cout<<"\r"<<i;
        long long r = find_persistance(i, 1).first;
        if(r == n) {
            cout<</*\rFound: "<<*/i;
            break;
        }
    }

    cout<<endl;
    return 0;
}
