#include <iostream>

using namespace std;

long long tree[1000001], prev[1000001];

void set(long long x, long long val)
{
    x ++;
    while(x <= 1000001)
    {
        tree[x] = max(tree[x], val);
        x += x & (-x);
    }
}

long long max(long long x)
{
    long long ans = 0;
    x ++;
    while(x > 0)
    {
        ans = max(ans, tree[x]);
        x -= x & (-x);
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    long long n;
    cin >> n;
    for(long long i = 0; i < n; i ++)
    {
        long long a;
        cin >> a;
        set(a, i + 1);
        long long curr = max(a - 1);
        cout << curr << " ";
    }
    cout << endl;
    return 0;
}
