#include <iostream>

using namespace std;

int tree[1000001], prev[1000001];

void set(int x, int val)
{
    x ++;
    while(x <= 1000001)
    {
        tree[x] = max(tree[x], val);
        x += x & (-x);
    }
}

int max(int x)
{
    int ans = 0;
    x ++;
    while(x > 0)
    {
        ans = max(ans, tree[x]);
        x -= x & (-x);
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin >> n;
    for(int i = 0; i < n; i ++)
    {
        int a;
        cin >> a;
        set(a, i + 1);
        int curr = max(a - 1);
        cout << curr << " ";
    }
    cout << endl;
    return 0;
}
