#include <iostream>
#include <vector>
#include <utility>

using namespace std;

const long long MAX_N = 1e5+10;

int n;
int mass[MAX_N];
int ans[MAX_N];
bool f = true;
vector<pair<int, int> > v;

int main()
{
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    
    cin >> n;
    cin >> mass[0];
    ans[0] = 0;
    for (int i = 1; i < n; ++ i)
    {
        cin >> mass[i];
        if (mass[i] > mass[i - 1])
        {
            ans[i] = i;
        }
    }
    for (int i = 0; i < n; ++ i)
    {
        if (ans[i] == 0)
        {
            v.push_back(make_pair(mass[i], i));
        }
    }
    while (f)
    {
        f = false;
        for (int i = v.size() - 1; i > 0; -- i)
        {
            if (v[i].first > v[i - 1].first && ans[v[i].second] == 0)
            {
                ans[v[i].second] = v[i - 1].second + 1;
                f = true;
            }
        }
    }
    for (int i = 0; i < n; ++ i)
    {
        cout << ans[i] << " ";
    }
    cout << endl;
    return 0;
}
