#include <iostream>
#include <stack>
#include <utility>

std::stack<std::pair<int, int> > k;

int main()
{
    k.push({0, 0});
    std::ios_base::sync_with_stdio(false);
    std::cin.tie();
    
    int n;
    std::cin >> n;
    for(int i = 1; i <= n; ++ i)
    {
        int curr;
        std::cin >> curr;
        
        while(curr < k.top().first)
        {
            k.pop();
        }
        
        std::cout << k.top().second << ' ';
        k.push({curr, i});
    }
    
    std::cout << '\n';
    
    return 0;
}