#include <iostream>
#include <stack>
#include <utility>

using namespace std;

const long long MAX_N = 1e5+10;

int n;
int mass[MAX_N];
int ans[MAX_N];
stack<pair<int, int> > k;

int main()
{
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    
    cin >> n;
    cin >> mass[0];
    ans[0] = 0;
    k.push(make_pair(mass[0], 0));
    for (int i = 1; i < n; ++ i)
    {
        cin >> mass[i];
        if (mass[i] > mass[i - 1])
        {
            ans[i] = i;
            k.push(make_pair(mass[i], i));
        }
        else
        {
            while (k.size() > 0 && mass[i] <= k.top().first)
            {
                k.pop();
            }
            if (k.size() == 0)
            {
                ans[i] = 0;
            }
            else
            {
                ans[i] = k.top().second + 1;
            }
            k.push(make_pair(mass[i], i));
        }
    }
    
    for (int i = 0; i < n; ++ i)
    {
        cout << ans[i] << " ";
    }
    cout << endl;
    return 0;
}
